package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes task category.
 */
public class Category extends Named implements Serializable, Comparable
{

    /** Store 1 if this category is project category (shown in upper-right dropdown box, etc).  */
    private Integer isproject; //persistent

    /** Workflow, related to this category */
    private Workflow workflow;
    /** Parent task for this category */
    private Task task;
    private Set catrelationSet = new HashSet(); //persistent
    private Set catrelationchildSet = new HashSet(); //persistent
    private Set cprstatusSet;
    private Set mailImportSet;

    public Category(String id, String name, Workflow workflow, Task task, Integer isp)
    {
        this.id = id;
        this.name = name;
        this.workflow = workflow;
        this.task = task;
        this.isproject = isp;
    }

    public Category()
    {
    }

    public Category(String id, Workflow workflow, Task task)
    {
        this.id = id;
        this.workflow = workflow;
        this.task = task;
    }

    public Workflow getWorkflow()
    {
        return this.workflow;
    }

    public void setWorkflow(Workflow workflow)
    {
        this.workflow = workflow;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }

    public Integer getIsproject()
    {
        return this.isproject;
    }

    public void setIsproject(Integer i)
    {
        this.isproject = i;
    }


    public boolean isProject()
    {
        if (this.getIsproject() != null && this.getIsproject().intValue() == 1) {
            return true;
        } else
            return false;
    }

    public Set getCatrelationSet()
    {
        return this.catrelationSet;
    }

    public void setCatrelationSet(Set catrelationSet)
    {
        this.catrelationSet = catrelationSet;
    }

    public Set getCatrelationchildSet()
    {
        return this.catrelationchildSet;
    }

    public void setCatrelationchildSet(Set catrelationSet)
    {
        this.catrelationchildSet = catrelationSet;
    }

    public Set getCprstatusSet()
    {
        return this.cprstatusSet;
    }

    public void setCprstatusSet(Set cprstatusSet)
    {
        this.cprstatusSet = cprstatusSet;
    }

     public Set getMailImportSet()
    {
        return this.mailImportSet;
    }

    public void setMailImportSet(Set mailImportSet)
    {
        this.mailImportSet = mailImportSet;
    }
}
