package gran.model;


import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** Describes common filter properties.
 */
public class Filter extends Named implements Serializable, Comparable
{

    private String description; //persistent
    private Integer active; //persistent
    private Integer priv; //persistent
    private Set subscriberSet = new HashSet(); //persistent
    private Set notificationSet = new HashSet(); //persistent
    private Set pruserSet = new HashSet(); //persistent
    private Set fvalueSet = new HashSet(); //persistent
    private Set reportSet = new HashSet(); //persistent

    private Task task;
    private User owner;


    public Filter(String id, String name, String description, Integer active, Integer priv, Task task, User owner)
    {
        this.id = id;
        this.name = name;
        this.description = description;
        this.active = active;
        this.priv = priv;
        this.task = task;
        this.owner = owner;
    }

    public Filter()
    {
    }

    public Filter(String id, Task task, User owner)
    {
        this.id = id;
        this.task = task;
        this.owner = owner;
    }


    public String getDescription()
    {
        return this.description;
    }

    public void setDescription(String description)
    {
        this.description = description;
    }

    public Integer getActive()
    {
        return this.active;
    }

    public void setActive(Integer active)
    {
        this.active = active;
    }

    public Integer getPriv()
    {
        return this.priv;
    }

    public void setPriv(Integer priv)
    {
        this.priv = priv;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }

    public User getOwner()
    {
        return this.owner;
    }

    public void setOwner(User owner)
    {
        this.owner = owner;
    }

    public Set getSubscriberSet()
    {
        return this.subscriberSet;
    }

    public void setSubscriberSet(Set subscriberSet)
    {
        this.subscriberSet = subscriberSet;
    }

    public Set getPruserSet()
    {
        return this.pruserSet;
    }

    public void setPruserSet(Set pruserSet)
    {
        this.pruserSet = pruserSet;
    }

    public Set getFvalueSet()
    {
        return this.fvalueSet;
    }

    public void setFvalueSet(Set fvalueSet)
    {
        this.fvalueSet = fvalueSet;
    }

    public Set getReportSet()
    {
        return reportSet;
    }

    public void setReportSet(Set reportSet)
    {
        this.reportSet = reportSet;
    }

    public Set getNotificationSet()
    {
        return this.notificationSet;
    }

    public void setNotificationSet(Set notificationSet)
    {
        this.notificationSet = notificationSet;
    }


}

