package gran.model;

import java.io.Serializable;
import java.sql.Timestamp;

/** Describes message (bug-note) */

public class Message implements Serializable, Comparable {
    private String id; //identifier
    private String description; //persistent
    private Timestamp time; //persistent
    private Double hrs; //persistent
    private Timestamp deadline; //persistent
    private Double budget; //persistent

    private User handler;
    private Resolution resolution;
    private Mstatus mstatus;
    private Pruser pruser;
    private Longtext longtext;
    private Priority priority;

    public Longtext getLongtext() {
        return longtext;
    }

    public void setLongtext(Longtext longtext) {
        this.longtext = longtext;
    }

    public Message(String id, Pruser pruser, Timestamp time, Mstatus mstatus, Double hrs, User handler, Resolution resolution, Priority priority, Timestamp deadline, Double budget) {
        this.id = id;
        this.pruser = pruser;
        this.time = time;
        this.mstatus = mstatus;
        this.hrs = hrs;
        this.handler = handler;
        this.resolution = resolution;
        this.priority = priority;
        this.deadline = deadline;
        this.budget = budget;
    }

    public Message() {
    }

    public Message(String id, Pruser pruser, Mstatus mstatus) {
        this.id = id;
        this.pruser = pruser;
        this.mstatus = mstatus;
    }

    public String getId() {
        return this.id;
    }

    public void setId(String id) {
        this.id = id;
    }


    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Pruser getPruser() {
        return this.pruser;
    }

    public void setPruser(Pruser pruser) {
        this.pruser = pruser;
    }

    public Timestamp getTime() {
        return this.time;
    }

    public void setTime(Timestamp time) {
        this.time = time;
    }

    public Mstatus getMstatus() {
        return this.mstatus;
    }

    public void setMstatus(Mstatus mstatus) {
        this.mstatus = mstatus;
    }

    public Double getHrs() {
        return this.hrs;
    }

    public void setHrs(Double hrs) {
        this.hrs = hrs;
    }

    public User getHandler() {
        return this.handler;
    }

    public void setHandler(User handler) {
        this.handler = handler;
    }

    public Priority getPriority() {
        return this.priority;
    }

    public void setPriority(Priority priority) {
        this.priority = priority;
    }

    public Timestamp getDeadline() {
        return this.deadline;
    }

    public void setDeadline(Timestamp deadline) {
        this.deadline = deadline;
    }

    public Double getBudget() {
        return this.budget;
    }

    public void setBudget(Double budget) {
        this.budget = budget;
    }

    public Resolution getResolution() {
        return this.resolution;
    }

    public void setResolution(Resolution resolution) {
        this.resolution = resolution;
    }

    public int compareTo(Object it) {
        int i= this.time.compareTo(((Message) it).getTime());
        if (i==0) return (time.toString()+id).compareTo(((Message) it).getTime().toString()+((Message) it).getId());
        return i;
    }

}
