package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes message type, for example, note,
 * resolve, close.
 */
public class Mstatus extends Named implements Serializable, Comparable
{

    private String description; //persistent
    private Integer isdefault; //persistent

    private Set resolutionSet = new HashSet(); //persistent
    private Set transitionSet = new HashSet(); //persistent
    private Set mprstatusSet = new HashSet(); //persistent
    private Set messageSet = new HashSet(); //persistent

    private Workflow workflow;

    public Mstatus(String id, String name, String description, Workflow workflow, Integer isdef)
    {
        this.id = id;
        this.name = name;
        this.description = description;
        this.workflow = workflow;
        this.isdefault = isdef;
    }

    public Mstatus()
    {
    }

    public Mstatus(String id, Workflow workflow)
    {
        this.id = id;
        this.workflow = workflow;
    }


    public String getDescription()
    {
        return this.description;
    }

    public void setDescription(String description)
    {
        this.description = description;
    }

    public Workflow getWorkflow()
    {
        return this.workflow;
    }

    public void setWorkflow(Workflow workflow)
    {
        this.workflow = workflow;
    }

    public Set getResolutionSet()
    {
        return this.resolutionSet;
    }

    public void setResolutionSet(Set resolutionSet)
    {
        this.resolutionSet = resolutionSet;
    }

    public Set getTransitionSet()
    {
        return this.transitionSet;
    }

    public void setTransitionSet(Set transitionSet)
    {
        this.transitionSet = transitionSet;
    }

    public Set getMprstatusSet()
    {
        return this.mprstatusSet;
    }

    public void setMprstatusSet(Set mprstatusSet)
    {
        this.mprstatusSet = mprstatusSet;
    }

    public Set getMessageSet()
    {
        return this.messageSet;
    }

    public void setMessageSet(Set messageSet)
    {
        this.messageSet = messageSet;
    }

    public Integer getIsdefault()
    {
        return this.isdefault;
    }

    public void setIsdefault(Integer i)
    {
        this.isdefault = i;
    }

    public boolean isDefault()
    {
        if (this.getIsdefault() != null && this.getIsdefault().intValue() == 1) {
            return true;
        } else
            return false;
    }



}
