package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes task priority. */

public class Priority implements Serializable, Comparable {
    private String id; //identifier
    private String name; //persistent
    private String description; //persistent
    private Integer order; //persistent
    private Integer def; //persistent
    private Workflow workflow;

    private Set taskSet = new HashSet(); //persistent
    private Set messageSet = new HashSet(); //persistent

    public Priority(String id, String name, String description, Integer order, Integer isdefault, Workflow workflow) {
        this.id = id;
        this.name = name;
        this.workflow = workflow;
        this.order = order;
        this.description = description;
        this.def = isdefault;
    }

    public Priority() {
    }

    public Priority(String id, String name, Integer order, Workflow workflow) {
        this.id = id;
        this.name = name;
        this.workflow = workflow;
        this.order = order;
    }

    public String getId() {
        return this.id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Workflow getWorkflow() {
        return this.workflow;
    }

    public void setWorkflow(Workflow workflow) {
        this.workflow = workflow;
    }

    public Integer getOrder() {
        return this.order;
    }

    public void setOrder(Integer order) {
        this.order = order;
    }

    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getDef() {
        return this.def;
    }

    public Integer getDefault() {
        return this.def;
    }

    public void setDef(Integer isdef) {
        if (isdef == null || isdef.intValue() == 0) {
            this.def = new Integer(0);
        } else
            this.def = new Integer(1);
    }

    public void setDefault(Integer isdef) {
        this.setDef(isdef);
    }

    public boolean isDefault() {
        if (def == null || def.intValue() == 0) {
            return false;
        } else
            return true;
    }

    public void setDefault() {
        this.def = new Integer(1);
    }

    public void unsetDefault() {
        this.def = new Integer(0);
    }

    public Set getTaskSet() {
        return this.taskSet;
    }

    public void setTaskSet(Set taskSet) {
        this.taskSet = taskSet;
    }

    public Set getMessageSet() {
        return this.messageSet;
    }

    public void setMessageSet(Set messageSet) {
        this.messageSet = messageSet;
    }

    public int compareTo(Object it) {
        Integer ord = this.order;
        if (ord == null) {
            ord = new Integer(-1);
        }
        Priority other =(Priority) it;
        if (other.getOrder()==null) return 1;

        int i = ord.compareTo((other).getOrder());
        if (i==0) return (order+id).compareTo(other.getOrder()+(other).getId());
        else return i;
    }

}
