package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes relation between user and task.
 * Also this class store information about active filter
 * and ACL settings.
 */
public class Pruser implements Serializable
{
    private String id; //identifier
    private Integer acl; //persistent
    private Set messageSet = new HashSet(); //persistent

    private Task task;
    private User user;
    private Filter filter;

    public Pruser(String id, Task task, User user, Integer acl, Filter filter)
    {
        this.id = id;
        this.task = task;
        this.user = user;
        this.acl = acl;
        this.filter = filter;
    }

    public Pruser()
    {
    }

    public Pruser(String id, Task task, User user)
    {
        this.id = id;
        this.task = task;
        this.user = user;
    }

    public String getId()
    {
        return this.id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }

    public User getUser()
    {
        return this.user;
    }

    public void setUser(User user)
    {
        this.user = user;
    }

    public Integer getAcl()
    {
        return this.acl;
    }

    public void setAcl(Integer acl)
    {
        this.acl = acl;
    }

    public Filter getFilter()
    {
        return this.filter;
    }

    public void setFilter(Filter filter)
    {
        this.filter = filter;
    }

    public Set getMessageSet()
    {
        return this.messageSet;
    }

    public void setMessageSet(Set messageSet)
    {
        this.messageSet = messageSet;
    }

}
