package gran.model;


import java.io.Serializable;

/** This class describe common settings of report */
public class Report extends Named implements Serializable, Comparable
{

    private Integer priv; //persistent
    private Rtype rtype;
    private Task task;
    private User owner;
    private Filter filter;
    /** Report-type-specific params. Used for distribution reports, for example */
    private String params; //persistent


    public Report(String id, String name, Integer priv, Rtype rtype, Filter filter, Task task, User owner)
    {
        this.id = id;
        this.name = name;
        this.priv = priv;
        this.rtype = rtype;
        this.task = task;
        this.owner = owner;
        this.filter = filter;
    }

    public Report(String id, String name, Integer priv, Rtype rtype, Filter filter, Task task, User owner, String params)
    {
        this.id = id;
        this.name = name;
        this.priv = priv;
        this.rtype = rtype;
        this.task = task;
        this.owner = owner;
        this.filter = filter;
        this.params = params;
    }

    public Report()
    {
    }

    public Report(String id, Task task, User owner, Filter filter, Rtype rtype)
    {
        this.id = id;
        this.task = task;
        this.owner = owner;
        this.filter = filter;
        this.rtype = rtype;
    }


    public Integer getPriv()
    {
        return this.priv;
    }

    public void setPriv(Integer priv)
    {
        this.priv = priv;
    }

    public Rtype getRtype()
    {
        return this.rtype;
    }

    public void setRtype(Rtype rtype)
    {
        this.rtype = rtype;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }

    public User getOwner()
    {
        return this.owner;
    }

    public void setOwner(User owner)
    {
        this.owner = owner;
    }

    public Filter getFilter()
    {
        return this.filter;
    }

    public void setFilter(Filter filter)
    {
        this.filter = filter;
    }

    public String getParams()
    {
        return this.params;
    }

    public void setParams(String params)
    {
        this.params = params;
    }



}
