package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes task resolution */
public class Resolution extends Named implements Serializable, Comparable {

    private Integer isdefault; //persistent
    private Set taskSet = new HashSet(); //persistent
    private Set messageSet = new HashSet(); //persistent

    private Mstatus mstatus;

    public Resolution(String id, String name, Mstatus mstatus, Integer isdefault) {
        this.id = id;
        this.name = name;
        this.mstatus = mstatus;
        this.isdefault = isdefault;
    }

    public Resolution() {
    }

    public Mstatus getMstatus() {
        return this.mstatus;
    }

    public void setMstatus(Mstatus mstatus) {
        this.mstatus = mstatus;
    }

    public Set getTaskSet() {
        return this.taskSet;
    }

    public void setTaskSet(Set taskSet) {
        this.taskSet = taskSet;
    }

    public Set getMessageSet() {
        return this.messageSet;
    }

    public void setMessageSet(Set messageSet) {
        this.messageSet = messageSet;
    }

    public Integer getIsdefault() {
        return this.isdefault;
    }

    public void setIsdefault(Integer i) {
        this.isdefault = i;
    }

    public boolean isDefault() {
        if (this.getIsdefault() != null && this.getIsdefault().intValue() == 1) {
            return true;
        } else
            return false;
    }


}
