package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** This class describes user role (right), for example,
 * ADD MESSAGE, DELETE TASK
 */
public class Role extends Named implements Serializable, Comparable
{

    private String description; //persistent

    private Set rolestatusSet = new HashSet();

    protected boolean set = false;

    public Role(String id, String name, String description)
    {
        this.id = id;
        this.name = name;
        this.description = description;
    }

    public Role()
    {
    }

    public Role(String id)
    {
        this.id = id;
    }


    public String getDescription()
    {
        return this.description;
    }

    public void setDescription(String description)
    {
        this.description = description;
    }

    public Set getRolestatusSet()
    {
        return rolestatusSet;
    }

    public void setRolestatusSet(Set rolestatusSet)
    {
        this.rolestatusSet = rolestatusSet;
    }


    public String getShortName()
    {
        return this.name.substring(this.name.indexOf("_") + 1);
    }

    public String getGroupName()
    {
        return this.name.substring(0, this.name.indexOf("_"));
    }

    public boolean isSet()
    {
        return this.set;
    }

    public void setSet(boolean b)
    {
        this.set = b;
    }


}
