package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/**
 * Describes task status.
 * Possible, this class should be refactored to State pattern
 */

public class Status extends Named implements Serializable, Comparable
{

    private Integer isstart; //persistent
    private Integer isfinish; //persistent
    private String color; //persistent
    private Set transitionStartSet = new HashSet(); //persistent
    private Set transitionFinishSet = new HashSet(); //persistent
    private Set taskSet = new HashSet(); //persistent

    private Workflow workflow;

    public Status(String id, String name, Integer start, Integer finish, Workflow workflow, String color)
    {
        this.id = id;
        this.name = name;
        this.isstart = start;
        this.isfinish = finish;
        this.workflow = workflow;
        this.color = color;
    }

    public Status()
    {
    }

    public Status(String id, Workflow workflow)
    {
        this.id = id;
        this.workflow = workflow;
    }


    public Integer getIsstart()
    {
        return this.isstart;
    }

    public void setIsstart(Integer start)
    {
        this.isstart = start;
    }

    public Integer getIsfinish()
    {
        return this.isfinish;
    }

    public void setIsfinish(Integer finish)
    {
        this.isfinish = finish;
    }

    public Workflow getWorkflow()
    {
        return this.workflow;
    }

    public void setWorkflow(Workflow workflow)
    {
        this.workflow = workflow;
    }

    public String getColor()
    {
        return this.color;
    }

    public void setColor(String color)
    {
        this.color = color;
    }

    public Set getTransitionStartSet()
    {
        return this.transitionStartSet;
    }

    public void setTransitionStartSet(Set transitionStartSet)
    {
        this.transitionStartSet = transitionStartSet;
    }

    public Set getTransitionFinishSet()
    {
        return this.transitionFinishSet;
    }

    public void setTransitionFinishSet(Set transitionFinishSet)
    {
        this.transitionFinishSet = transitionFinishSet;
    }

    public Set getTaskSet()
    {
        return this.taskSet;
    }

    public void setTaskSet(Set taskSet)
    {
        this.taskSet = taskSet;
    }

    public boolean isStart()
    {
        if (this.isstart != null && this.isstart.intValue() == 1) {
            return true;
        } else
            return false;
    }

    public boolean isFinish()
    {
        if (this.isfinish != null && this.isfinish.intValue() == 1) {
            return true;
        } else
            return false;
    }

    public boolean makeFinish()
    {
        this.isfinish = new Integer(1);
        return true;
    }

    public boolean resetFinish()
    {
        this.isfinish = new Integer(0);
        return false;
    }

    public boolean makeStart()
    {
        this.isstart = new Integer(1);
        return true;
    }

    public boolean resetStart()
    {
        this.isstart = new Integer(0);
        return false;
    }



}