package gran.model;

import java.io.Serializable;
import java.sql.Timestamp;

/** Describes filter subscription settings for
 * specified user, task and filter
 */
public class Subscriber implements Serializable
{
    private String id; //identifier

    private Timestamp startdate; //persistent
    private Timestamp stopdate; //persistent
    private Timestamp nextrun; //persistent
    private Integer interval; //persistent

    private User user;
    private Filter filter;
    private Task task;


    public Subscriber(String id, User user, Filter filter, Task task, Timestamp startdate, Timestamp stopdate, Timestamp nextrun, Integer interval)
    {
        this.id = id;
        this.user = user;
        this.filter = filter;
        this.task = task;
        this.startdate = startdate;
        this.stopdate = stopdate;
        this.nextrun = nextrun;
        this.interval = interval;
    }

    public Subscriber()
    {
    }

    public Subscriber(String id, User user, Filter filter, Task task)
    {
        this.id = id;
        this.user = user;
        this.filter = filter;
        this.task = task;
    }

    public String getId()
    {
        return this.id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public User getUser()
    {
        return this.user;
    }

    public void setUser(User user)
    {
        this.user = user;
    }

    public Filter getFilter()
    {
        return this.filter;
    }

    public void setFilter(Filter filter)
    {
        this.filter = filter;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }


    public Timestamp getStartdate()
    {
        return this.startdate;
    }

    public void setStartdate(Timestamp startdate)
    {
        this.startdate = startdate;
    }

    public Timestamp getStopdate()
    {
        return this.stopdate;
    }

    public void setStopdate(Timestamp stopdate)
    {
        this.stopdate = stopdate;
    }

    public Timestamp getNextrun()
    {
        return this.nextrun;
    }

    public void setNextrun(Timestamp nextrun)
    {
        this.nextrun = nextrun;
    }

    public Integer getInterval()
    {
        return this.interval;
    }

    public void setInterval(Integer interval)
    {
        this.interval = interval;
    }

}
