package gran.model;


import java.io.Serializable;
import java.sql.Timestamp;
import java.util.HashSet;
import java.util.Set;
import java.util.Comparator;

/** Describes tasks */
public class Task extends Named implements Serializable, Comparable {


    private String shortname; //persistent

    private Timestamp submitdate; //persistent
    private Timestamp updatedate; //persistent
    private Timestamp closedate; //persistent
    private String description; //persistent
    private Double abudget; //persistent
    private Double budget; //persistent
    private Timestamp deadline; //persistent
    private String number;

    private Set filterSet = new HashSet(); //persistent
    private Set subscriberSet = new HashSet(); //persistent
    private Set notificationSet = new HashSet(); //persistent
    private Set pruserSet = new HashSet(); //persistent
    private Set categorySet = new HashSet(); //persistent
    private Set workflowSet = new HashSet(); //persistent
    private Set udfsourceSet = new HashSet(); //persistent
    private Set childSet = new HashSet(); //persistent
    private Set reportSet = new HashSet(); //persistent
    private Set mailImportSet;
    private Set defaultProjectSet;

    private User submitter;
    private User handler;
    private Task parent;
    private Category category;
    private Status status;
    private Resolution resolution;
    private Priority priority;

    public Longtext getLongtext() {
        return longtext;
    }

    public void setLongtext(Longtext longtext) {
        this.longtext = longtext;
    }

    private Longtext longtext;

    public Task(String id, String shortname, String name, Timestamp submitdate, Timestamp updatedate, Timestamp closedate, String description, Double abudget, Double budget, Timestamp deadline, Category category, Status status, Resolution resolution, Priority priority, User submitter, User handler, Task parent) {
        this.id = id;
        this.shortname = shortname;
        this.name = name;
        this.submitdate = submitdate;
        this.updatedate = updatedate;
        this.closedate = closedate;
        this.description = description;
        this.abudget = abudget;
        this.budget = budget;
        this.deadline = deadline;
        this.category = category;
        this.status = status;
        this.resolution = resolution;
        this.priority = priority;
        this.submitter = submitter;
        this.handler = handler;
        this.parent = parent;
    }

    public Task() {
    }

    public Task(String id, String name, Category category, Status status, Resolution resolution, User submitter, User handler, Task parent) {
        this.id = id;
        this.name = name;
        this.category = category;
        this.status = status;
        this.resolution = resolution;
        this.submitter = submitter;
        this.handler = handler;
        this.parent = parent;

    }


    public String getShortname() {
        return this.shortname;
    }

    public void setShortname(String shortname) {
        this.shortname = shortname;
    }


    public Timestamp getSubmitdate() {
        return this.submitdate;
    }

    public void setSubmitdate(Timestamp submitdate) {
        this.submitdate = submitdate;
    }

    public Timestamp getUpdatedate() {
        return this.updatedate;
    }

    public void setUpdatedate(Timestamp updatedate) {
        this.updatedate = updatedate;
    }

    public Timestamp getClosedate() {
        return this.closedate;
    }

    public void setClosedate(Timestamp closedate) {
        this.closedate = closedate;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {

        this.description = description;
    }

    public Double getAbudget() {
        return this.abudget;
    }

    public void setAbudget(Double abudget) {
        this.abudget = abudget;
    }

    public Double getBudget() {
        return this.budget;
    }

    public void setBudget(Double budget) {
        this.budget = budget;
    }

    public Timestamp getDeadline() {
        return this.deadline;
    }

    public void setDeadline(Timestamp deadline) {
        this.deadline = deadline;
    }

    public Category getCategory() {
        return this.category;
    }

    public void setCategory(Category category) {
        this.category = category;
    }

    public Status getStatus() {
        return this.status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public Resolution getResolution() {
        return this.resolution;
    }

    public void setResolution(Resolution resolution) {
        this.resolution = resolution;
    }

    public Priority getPriority() {
        return this.priority;
    }

    public void setPriority(Priority priority) {
        this.priority = priority;
    }

    public User getSubmitter() {
        return this.submitter;
    }

    public void setSubmitter(User submitter) {
        this.submitter = submitter;
    }

    public User getHandler() {
        return this.handler;
    }

    public void setHandler(User handler) {
        this.handler = handler;
    }

    public Task getParent() {
        return this.parent;
    }

    public void setParent(Task parent) {
        this.parent = parent;
    }

    public Set getFilterSet() {
        return this.filterSet;
    }

    public void setFilterSet(Set filterSet) {
        this.filterSet = filterSet;
    }

    public Set getSubscriberSet() {
        return this.subscriberSet;
    }

    public void setSubscriberSet(Set subscriberSet) {
        this.subscriberSet = subscriberSet;
    }

    public Set getNotificationSet() {
        return this.notificationSet;
    }

    public void setNotificationSet(Set subscriberSet) {
        this.notificationSet = subscriberSet;
    }

    public Set getPruserSet() {
        return this.pruserSet;
    }

    public void setPruserSet(Set pruserSet) {
        this.pruserSet = pruserSet;
    }

    public Set getCategorySet() {
        return this.categorySet;
    }

    public void setCategorySet(Set categorySet) {
        this.categorySet = categorySet;
    }

    public Set getWorkflowSet() {
        return this.workflowSet;
    }

    public void setWorkflowSet(Set workflowSet) {
        this.workflowSet = workflowSet;
    }

    public Set getUdfsourceSet() {
        return this.udfsourceSet;
    }

    public void setUdfsourceSet(Set udfsourceSet) {
        this.udfsourceSet = udfsourceSet;
    }

    public Set getChildSet() {
        return childSet;
    }

    public void setChildSet(Set childSet) {
        this.childSet = childSet;
    }

    public Set getReportSet() {
        return reportSet;
    }


    public void setReportSet(Set reportSet) {
        this.reportSet = reportSet;
    }

    public Set getMailImportSet() {
        return this.mailImportSet;
    }

    public void setMailImportSet(Set mailImportSet) {
        this.mailImportSet = mailImportSet;
    }

    public Set getDefaultProjectSet() {
        return this.defaultProjectSet;
    }

    public void setDefaultProjectSet(Set defaultProjectSet) {
        this.defaultProjectSet = defaultProjectSet;
    }

    public String getNumber() {
        return this.number;
    }

    public void setNumber(String number) {
        this.number = number;
    }


    public String getTaskNameCutted() {
            if (getShortname() != null && !getShortname().equals("")) {
                return getShortname();
            } else if (getName() != null && !getName().equals("")) {
                return sizeTrim(getName());
            } else {
                return "NoName";
            }
    }

    /** Trim string, use it to trim long task name */
    private String sizeTrim(String name) {
        String ret = name;

        if (name == null || name.equals(""))
            return "NoName";

        if (name.length() > 27) {
            ret = ret.substring(0, 24);
            ret += "...";
        }

        return ret;
    }

}
