package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;
import java.util.Comparator;

/** Describes available values in dropdown UDF list */
public class Udflist implements Serializable, Comparable
{
    private String id; //identifier
    private String val; //persistent
    private Integer order; //persistent
    private Set udfvalSet = new HashSet(); //persistent

    private Udf udf;


    public Udflist(String id, String val, Integer order, Udf udf)
    {
        this.id = id;
        this.val = val;
        this.order = order;
        this.udf = udf;
    }

    public Udflist()
    {
    }

    public Udflist(String id, Udf udf)
    {
        this.id = id;
        this.udf = udf;
    }

    public String getId()
    {
        return this.id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public String getVal()
    {
        return this.val;
    }

    public void setVal(String val)
    {
        this.val = val;
    }

    public Integer getOrder()
    {
        return this.order;
    }

    public void setOrder(Integer order)
    {
        this.order = order;
    }

    public Udf getUdf()
    {
        return this.udf;
    }

    public void setUdf(Udf udf)
    {
        this.udf = udf;
    }

    public Set getUdfvalSet()
    {
        return this.udfvalSet;
    }

    public void setUdfvalSet(Set udfvalSet)
    {
        this.udfvalSet = udfvalSet;
    }

    public int compareTo(Object it)
    {

        int i =this.getVal().compareTo(((Udflist) it).getVal());
        if (i==0) return (this.getVal()+this.getId()).compareTo(((Udflist) it).getVal()+((Udflist) it).getId());
        else return i;
    }

    /**
     * Returns ordered comparator
     * @return
     */
    public Comparator getOrderedComparator(){
        return new Comparator(){
            public int compare(Object o1, Object o2) {
                return ((Udflist)o2).getOrder().compareTo(((Udflist) o1).getOrder());
            }

        };
    }

    public Comparator getValueComparator(){
        return new Comparator(){
            public int compare(Object o1, Object o2) {
                return ((Udflist)o1).getVal().compareTo(((Udflist) o2).getVal());
            }

        };
    }
}
