package gran.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

/** Describes items (task, users, workflows) that can
 * hold UDFs.
 */
public class Udfsource implements Serializable
{
    private String id; //identifier
    private Set udfvalSet = new HashSet(); //persistent
    private Set udfSet = new HashSet(); //persistent

    private Task task;
    private User user;
    private Workflow workflow;

    public Udfsource(String id, Task task, User user, Workflow workflow)
    {
        this.id = id;
        this.task = task;
        this.user = user;
        this.workflow = workflow;
    }

    public Udfsource()
    {
    }

    public Udfsource(String id)
    {
        this.id = id;
    }

    public String getId()
    {
        return this.id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public Task getTask()
    {
        return this.task;
    }

    public void setTask(Task task)
    {
        this.task = task;
    }

    public User getUser()
    {
        return this.user;
    }

    public void setUser(User user)
    {
        this.user = user;
    }

    public Workflow getWorkflow()
    {
        return this.workflow;
    }

    public void setWorkflow(Workflow workflow)
    {
        this.workflow = workflow;
    }

    public Set getUdfvalSet()
    {
        return this.udfvalSet;
    }

    public void setUdfvalSet(Set udfvalSet)
    {
        this.udfvalSet = udfvalSet;
    }

    public Set getUdfSet()
    {
        return this.udfSet;
    }

    public void setUdfSet(Set udfSet)
    {
        this.udfSet = udfSet;
    }
}
