package gran.model;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.HashSet;
import java.util.Set;

import gran.tools.formatter.DateFormatter;

/** Describes user */
public class User extends Named implements Serializable, Comparable {

    private String login; //persistent
    private String password; //persistent

    private String tel; //persistent
    private String email; //persistent
    private String smsmail; //persistent
    private Integer active; //persistent
    private String service; //persistent
    private String locale; //persistent
    private String timezone; //persistent
    private String company; //persistent
    private Timestamp lastVisited; //persistent
    private Integer childAllowed; //persistent
    private Timestamp expireDate; //persistent

    private Set prstatusSet = new HashSet(); //persistent
    private Set pruserSet = new HashSet(); //persistent
    private Set udfsourceSet = new HashSet(); //persistent
    private Set subscriberSet = new HashSet(); //persistent
    private Set notificationSet = new HashSet(); //persistent
    private Set filterSet = new HashSet(); //persistent
    private Set messageSet = new HashSet(); //persistent
    private Set taskSubmitterSet = new HashSet(); //persistent
    private Set taskHandlerSet = new HashSet(); //persistent
    private Set childSet = new HashSet(); //persistent
    private Set reportSet = new HashSet(); //persistent
    private Set mailImportSet;

    private Prstatus prstatus;
    private User manager;
    private EmailType emailType;
    private Task defaultProject;

    public User(String id, String login, String password, String name, String tel, String email, String smsmail, Integer active, Prstatus prstatus, String service, String locale, String timezone, Timestamp lastVisited, Integer childAllowed, User manager, EmailType emailType) {
        this.id = id;
        this.login = login;
        this.password = password;
        this.name = name;
        this.tel = tel;
        this.email = email;
        this.smsmail = smsmail;
        this.active = active;
        this.prstatus = prstatus;
        this.service = service;
        this.locale = locale;
        this.timezone = timezone;
        this.lastVisited = lastVisited;
        this.childAllowed = childAllowed;
        this.manager = manager;
        this.emailType = emailType;
    }

    public User() {
    }


    public User(String id, String login, String name, Prstatus prstatus, User manager) {
        this.id = id;
        this.login = login;
        this.name = name;
        this.prstatus = prstatus;
        this.manager = manager;
    }



    public String getLogin() {
        return this.login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPassword() {
        return this.password;
    }

    public void setPassword(String password) {
        this.password = password;
    }


    public String getTel() {
        return this.tel;
    }

    public void setTel(String tel) {
        this.tel = tel;
    }

    public String getEmail() {
        return this.email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getSmsmail() {
        return this.smsmail;
    }

    public void setSmsmail(String smsmail) {
        this.smsmail = smsmail;
    }

    public Integer getActive() {
        return this.active;
    }

    public void setActive(Integer active) {
        this.active = active;
    }

    public Prstatus getPrstatus() {
        return this.prstatus;
    }

    public void setPrstatus(Prstatus prstatus) {
        this.prstatus = prstatus;
    }

    public String getService() {
        return this.service;
    }

    public void setService(String service) {
        this.service = service;
    }

    public String getLocale() {
        return this.locale;
    }

    public void setLocale(String locale) {
        this.locale = locale;
    }

    public String getTimezone() {
        return this.timezone;
    }

    public void setTimezone(String timezone) {
        this.timezone = timezone;
    }

    public Timestamp getLastVisited() {
        return this.lastVisited;
    }

    public void setLastVisited(Timestamp lastVisited) {
        this.lastVisited = lastVisited;
    }

    public String getCompany() {
        return this.company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    public Integer getChildAllowed() {
        return this.childAllowed;
    }

    public void setChildAllowed(Integer childAllowed) {
        this.childAllowed = childAllowed;
    }

    public User getManager() {
        return this.manager;
    }

    public void setManager(User manager) {
        this.manager = manager;
    }

    public EmailType getEmailType() {
        return this.emailType;
    }

    public void setEmailType(EmailType emailType) {
        this.emailType = emailType;
    }

    public Timestamp getExpireDate() {
        return this.expireDate;
    }

    public void setExpireDate(Timestamp expireDate) {
        this.expireDate = expireDate;
    }

    public Task getDefaultProject() {
        return this.defaultProject;
    }

    public void setDefaultProject(Task defaultProject) {
        this.defaultProject = defaultProject;
    }

    public Set getPrstatusSet() {
        return this.prstatusSet;
    }

    public void setPrstatusSet(Set prstatusSet) {
        this.prstatusSet = prstatusSet;
    }

    public Set getPruserSet() {
        return this.pruserSet;
    }

    public void setPruserSet(Set pruserSet) {
        this.pruserSet = pruserSet;
    }

    public Set getUdfsourceSet() {
        return this.udfsourceSet;
    }

    public void setUdfsourceSet(Set udfsourceSet) {
        this.udfsourceSet = udfsourceSet;
    }

    public Set getSubscriberSet() {
        return this.subscriberSet;
    }

    public void setSubscriberSet(Set subscriberSet) {
        this.subscriberSet = subscriberSet;
    }

    public Set getNotificationSet() {
        return this.notificationSet;
    }

    public void setNotificationSet(Set notificationSet) {
        this.notificationSet = notificationSet;
    }

    public Set getFilterSet() {
        return this.filterSet;
    }

    public void setFilterSet(Set filterSet) {
        this.filterSet = filterSet;
    }

    public Set getMessageSet() {
        return this.messageSet;
    }

    public void setMessageSet(Set messageSet) {
        this.messageSet = messageSet;
    }

    public Set getTaskSubmitterSet() {
        return this.taskSubmitterSet;
    }

    public void setTaskSubmitterSet(Set taskSubmitterSet) {
        this.taskSubmitterSet = taskSubmitterSet;
    }

    public Set getTaskHandlerSet() {
        return this.taskHandlerSet;
    }

    public void setTaskHandlerSet(Set taskHandlerSet) {
        this.taskHandlerSet = taskHandlerSet;
    }

    public Set getChildSet() {
        return childSet;
    }

    public void setChildSet(Set childSet) {
        this.childSet = childSet;
    }

    public Set getReportSet() {
        return reportSet;
    }

    public void setReportSet(Set reportSet) {
        this.reportSet = reportSet;
    }

    public Set getMailImportSet() {
        return this.mailImportSet;
    }

    public void setMailImportSet(Set mailImportSet) {
        this.mailImportSet = mailImportSet;
    }

    public DateFormatter getDateFormatter() {
        return new DateFormatter(this);
    }





    public String toString() {
        return this.getName();
    }
}
